




/* Titan Loader START */
$setTargetPoint = function () {
    $("." + $controlListClass + " ." + $itemsHolderClass + ":last-child").after("<div data-target-point='true'></div>");
};


$moveTargetPointToEnd = function () {
    // Remove the existing target point but keep its contents in place
    $removeOldTargetPoint = $("[data-target-point]");
    $removeOldTargetPoint.replaceWith($removeOldTargetPoint.html());

    // Now put the new target point at the end of the last ul again
    $("." + $controlListClass + " ." + $itemsHolderClass + ":last").after("<div data-target-point='true'></div>");
};


$addFocusOnNewList = function () {
    // For the web view, remove the focus on the previous list and put it on the new one
    $("." + $controlListClass + " ." + $itemsHolderClass + "").removeClass("inFocus");
    $("." + $controlListClass + " ." + $itemsHolderClass + ":last").addClass("inFocus");
};

$viewMoreButtonInitialCheck = function () {

    // If theres another page after the current li then display the 'more items' button
    if (($("." + $paginationPointClass + ":first ul li[" + $paginationNormal + "]:last").hasClass("" + $currentPaginationItemClass + "")))
	{
    }
	else
	{
		if (($("." + $paginationPointClass + ":first ul li[" + $paginationNormal + "]").length)) // NEW CONDITION ADDED IN. If any normal pagination numbers exist at all
		{
			// Create button
			$("[" + $viewMoreButtonPoint + "]").wrapInner("<div class='" + $viewMoreButtonClass + "'><a>" + $defaultLoadButtonText + "</a></div>");
		}
	}
};

$viewMoreButtonSubsequentCheck = function () {
    if (($("." + $paginationPointClass + ":first ul li[" + $paginationNormal + "]:last").hasClass("" + $currentPaginationItemClass + ""))) {
        // Then hide the button
        $("[" + $viewMoreButtonPoint + "]").css("display", "none");
    }
    else {
        $("[" + $viewMoreButtonPoint + "]").css("display", "block");
    }
}



$viewMoreButtonLoader = function () {

    $("body").addClass("titanMoreButtonEnabled");

    // Is the view button required?
    $viewMoreButtonInitialCheck();


    // When you click the view more items buttons...
    $("[" + $viewMoreButtonPoint + "] a").click(function () {

        

        // Get the href of the next li in the sequence
        $dataImportURL = $("." + $paginationPointClass + ":first ul:first li." + $currentPaginationItemClass + "").next().find('a').attr("href");

	// Load in pagination from page
	$("." + $paginationPointClass + "").load($dataImportURL + " " + "." + $paginationPointClass + ":first ul", function () {
		$viewMoreButtonSubsequentCheck();
	});
        


        // Prepare loading
        var timeout;
        $.ajax({
            url: $dataImportURL + " " + "." + $itemsHolderClass + "",
            beforeSend: function () {
                // Before we get the data, change the loading text of the view more button so the user knows something is happening
                $("[" + $viewMoreButtonPoint + "] a").text("" + $loadingInProgressButtonText + "");
            },
            complete: function (data) {


                


                // Now load the data into it's designated target point
                $("[data-target-point]").load($dataImportURL + " " + "." + $itemsHolderClass + "", function () {



                    



                    


                    $("[" + $viewMoreButtonPoint + "] a").text("" + $defaultLoadButtonText + "");


                    
                    $moveTargetPointToEnd();
                    $addFocusOnNewList();
                    $animatePanelLoader();
                    
					
											
					/* Run any callback functions entered into the data tag. All functions to be seperated by commas. Functions are run in order START */
					var viewMoreButtonCallbackFunctions = $("[" + $viewMoreButtonPoint + "]").data("callback-functions");
					eval(viewMoreButtonCallbackFunctions);
					/* Run any callback functions entered into the data tag. All functions to be seperated by commas. Functions are run in order END */


		


                });

            }
        });



    });

};






$animatePanelLoader = function () {
    // If the animation setting has been set


    // Then prevent the pagination click
    $("." + $paginationPointClass + " a").click(function (e) {

        e.preventDefault(); // Prevent going to the link
        
        
        // Remove any uls out of focus which might just be hidden from the 'view more buttons' feature
        $("." + $controlListClass + " ." + $itemsHolderClass + ":not(.inFocus)").remove();


        $dataImportURL = $(this).attr("href"); // Get the href

        // Load in pagination from page
        $("." + $paginationPointClass + "").load($dataImportURL + " " + "." + $paginationPointClass + ":first ul", function () {
				$viewMoreButtonSubsequentCheck();
        });
        
            $initialContentHeight = $("." + $controlListClass + "").outerHeight();
            $collectionPointHeight = $("." + $itemsHolderClass + "").outerHeight();


            $("." + $controlListClass + "").css("height", $initialContentHeight); // Set the first panel height

            $("." + $itemsHolderClass + "").fadeOut("slow", function () { // Fade out the old section and delete it from the page

                $("." + $itemsHolderClass + "").remove(); // Then remove the collection point

                $("." + $controlListClass + "").addClass("animate");

                $("[data-target-point]").animate({ opacity: 0 }, 0, function () {




                    var timeout;
                    $.ajax({
                        url: $dataImportURL + " " + "." + $itemsHolderClass + "",
                        beforeSend: function () {
                            timeout = setTimeout(function () {
                                $("#ajaxLoader").fadeIn("slow"); // If the load from the external page collection point is taking longer than 1 second, fade in the loading screen
                            }, 4000);
                        },
                        complete: function (data) {
                            clearTimeout(timeout);
                            $("#ajaxLoader").fadeOut("slow", function () { // When the contents loaded, fade out the loading screen.


                                $("[data-target-point]").load($dataImportURL + " " + "." + $itemsHolderClass + "", function () {
                                    $newContentHeight = $("[data-target-point]").outerHeight();



                                    $("." + $controlListClass + "").animate({ height: $newContentHeight }, function () { // Animate to the new target height
                                        $("[data-target-point]").animate({ opacity: 1 }, function () { // Animate the opacity to full

                                            $("." + $controlListClass + "").css({ height: '' });


                                            $moveTargetPointToEnd();
                                            $addFocusOnNewList();
                                            $animatePanelLoader();
                                            

											
											
											
											
								/* Run any callback functions entered into the data tag. All functions to be seperated by commas. Functions are run in order START */
								var paginationCallbackFunctions = $("." + $paginationPointClass + "").data("callback-functions");
								eval(paginationCallbackFunctions);
								/* Run any callback functions entered into the data tag. All functions to be seperated by commas. Functions are run in order END */
											
											
											
											
											

                                            $("." + $controlListClass + "").removeClass("animate");



                                        });
                                    });
                                });
                            });




                        }
                    });




                });



            });

       









    });
};






$titanLoader = function () {



    /* Set variables START */
	$viewMoreButtonPoint = "data-more-button-point";

	/* If no data-idle-text has been declared we put in a default value START */
	if (($('[data-more-button-point]').attr('data-idle-text') == null))
	{
		$defaultLoadButtonText = "View more...";
	}
	else
	{
		$defaultLoadButtonText = $('[data-more-button-point]').attr('data-idle-text');
	};
	/* If no data-idle-text has been declared we put in a default value END */

	/* If no data-loading-text has been declared we put in a default value START */
	if (($('[data-more-button-point]').attr('data-loading-text') == null))
	{
		$loadingInProgressButtonText = "loading...";
	}
	else
	{
		$loadingInProgressButtonText = $('[data-more-button-point]').attr('data-loading-text');
	};
	/* If no data-loading-text has been declared we put in a default value END */

    $controlListClass = "titanLoaderControlList";
	$itemsHolderClass = "titanLoaderItemsHolder";    
    $currentPaginationItemClass = "pageOn";
    $viewMoreButtonClass = "titanViewMoreItems";
	
	/* Pagination calculations START */
	$paginationPointClass = "titanLoaderPagination";
    $paginationNormal = "data-pagination-normal";
    $paginationPrevious = "data-pagination-previous";
    $paginationNext = "data-pagination-next";
    $numOfLis = $("." + $paginationPointClass + " li:not([" + $paginationPrevious + "]):not([" + $paginationNext + "])").length;
    $positionOfCurrentLi = $("." + $paginationPointClass + " li." + $currentPaginationItemClass + "").prevAll("li:not([" + $paginationPrevious + "]):not([" + $paginationNext + "])").size() + 1;
	/* Pagination calculations END */
	
    /* Set variables END */

    /* Initial set-up START */
    $addFocusOnNewList();
    $setTargetPoint();
    /* Initial set-up END */


    /* If the 'view more' button exists on the page then load the protocols START */
    if (($("[" + $viewMoreButtonPoint + "]").is("*"))) {
        $viewMoreButtonLoader();
    }
    /* If the 'view more' button exists on the page then load the protocols END */



    /* If the set animation parameter has been set on the control list then load the protocols START */
    if (($("." + $controlListClass + "").is("[data-animation-required]"))) {
        $animatePanelLoader();
    }
    /* If the set animation parameter has been set on the control list then load the protocols END */

};
/* Titan Loader END */